// lbg[N֘ANX
#ifndef _TTNETWORK_H_
#define _TTNETWORK_H_

#include <winsock2.h>

class TtTcpSocket;

class TtTcpSocket {

  // -- static -----------------------------------------------------------
private:
  static int static_error_id;

public:
  static bool init();
  static bool cleanup();
  static int get_static_error_id();

  // -- instance -----------------------------------------------------------
protected:
  SOCKET sock;
  int timeout;

  int last_error_id;

public:

  TtTcpSocket();

  bool set_timeout( int timeout );
  int get_timeout();

  bool connect( char *host, int port );
  bool close();

  bool read_int( int *data );
  bool read_char( char *data );
  bool read_bytes( char *data, int size );
  bool read_line( char *data, int max );
  int recv( char *buf, int len, int flags );

  bool write_int( int data );
  bool write_char( char data );
  bool write_bytes( const char *data, int size );
  bool write_string( const char *data );
  bool write_line( const char *data );
  int send( const char *buf, int len, int flags );

  int get_error_id();
  bool get_error_message( char *buf, int max );

protected:
  void error_setting();
};

#endif // _TTNETWORK_H_
