// t@C֘ANX
#ifndef _TTFILE_H_
#define _TTFILE_H_

class TtIniFile;
class TtIniSection;

namespace TtPath {
  void edit_path( char *target, bool f_drive, bool f_dir, bool f_fname, bool f_ext );
  void get_exec_file_name( char *buf, int max );
}



class TtIniFile {

  // -- instance -----------------------------------------------------------
protected:
  char *file_name;

  ~TtIniFile();

public:

  // ftHg exe Ɠt@C .ini ̃t@C
  TtIniFile();
  TtIniFile( const char *file_name );

  const char *get_file_name();
  void set_file_name( const char *file_name );

  TtIniSection *get_section( char *name );

  void flush();
};


class TtIniSection {
  friend TtIniFile;

  // -- instance -----------------------------------------------------------
protected:
  TtIniFile *ini_file;
  char *name;

  TtIniSection( TtIniFile *ini_file, const char *name );
  ~TtIniSection();

public:

  TtIniFile *get_ini_file();
  
  const char *get_name();
  void set_name( const char *name );
  
  int get_int( const char *key );
  int get_int( const char *key, int default_int );
  int get_str( const char *key, char *buf, int buf_size );
  int get_str( const char *key, char *buf, int buf_size, const char *default_str );

  bool set_int( const char *key, int data );
  bool set_str( const char *key, const char *data );

  void flush();
};

#endif // _TTFILE_H_
